#ifndef INTEGERH
#define INTEGERH 

/* Integer.h -- declarations for Integer object

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Object.h"

extern Class class_Integer;

class Integer: public Object {
	int val;
	void parseInteger(istream& strm)	{ strm >> val; }
public:
	Integer(int v =0)		{ val = v; }
	Integer(istream&);
	Integer(fileDescTy&,Integer&);
	Integer(istream&,Integer&);
	int value()			{ return val; }
	int value(int newval)		{ return val = newval; }
	virtual int compare(const Object&);
	virtual obid	copy();			// { return shallowCopy(); }
	virtual void	deepenShallowCopy();	// {}
	virtual UNSIGNED hash();
	virtual const Class* isA();
	virtual bool isEqual(const Object&);
	virtual void printOn(ostream& strm);
	virtual void scanFrom(istream& strm);
	virtual const Class* species();
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
